#pragma once

#include "Sion/Gui/Cp/TreeOptionsCtrl.h"
#include "Preferences.h"
#include "OtherFunctions.h"
// CPPgTweaks2 dialog

class CPPgTweaks2 : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgTweaks2)

public:
	CPPgTweaks2();
	virtual ~CPPgTweaks2();


	enum { IDD = IDD_PPG_TWEAKS2}; 

protected:

	CTreeOptionsCtrl m_ctrlTreeOptions; // NEO: FIX - [TreeControl] 
	bool m_bInitializedTreeOpts;

	HTREEITEM m_htiXPMenu;

//dlarge QuickStart
	bool	m_bQuickStart;
	int		m_iQuickStartTime;
	//int		m_iQuickStartTimePerFile;
	int		m_iQuickMaxConperFive;
	int		m_iQuickMaxHalfOpen;
	int		m_iQuickMaxConnections;
//dlarge end

//dlarge Smart Category Control 
	int m_iDlMode;
	bool m_bShowCatNames;
	bool m_bSelectCat;
	bool m_bUseActiveCat;
	bool m_bAutoSetResOrder;
	bool m_bSmallFileDLPush;
	int m_iResumeFileInNewCat;
	bool m_bUseAutoCat;
//dlarge end

	bool m_bSUQWT; //dlarge SUQWT 

//dlarge Drop
	int iMaxRemoveQRS;
	int m_iDropSources;
	bool m_iDropSourcesNNS;
	int m_iDropSourcesTimerNNS;
	bool m_iDropSourcesFQ;
	int m_iDropSourcesTimerFQ;
	bool m_iDropSourcesHQR;
	int m_iDropSourcesTimerHQR;
//dlarge end

//dlarge QuickStart
		HTREEITEM m_htiQuickStart;
			HTREEITEM m_htiQuickStartEnable;
			HTREEITEM m_htiQuickStartTime;
			//HTREEITEM m_htiQuickStartTimePerFile;
			HTREEITEM m_htiQuickMaxConperFive;
			HTREEITEM m_htiQuickMaxHalfOpen;
			HTREEITEM m_htiQuickMaxConnections;
//dlarge end

//dlarge high process priority 
	HTREEITEM m_htiHighProcess;
	HTREEITEM m_htiHighProcessMode_low;
	HTREEITEM m_htiHighProcessMode_lower;
	HTREEITEM m_htiHighProcessMode_normal;
	HTREEITEM m_htiHighProcessMode_higher;
	HTREEITEM m_htiHighProcessMode_high;
	int m_iHighProcessMode;
//dlarge end

//dlarge Drop
	HTREEITEM m_htiDropSources;
	HTREEITEM m_htiDropSourcesNNS;
	HTREEITEM m_htiDropSourcesTimerNNS;
	HTREEITEM m_htiDropSourcesFQ;
	HTREEITEM m_htiDropSourcesTimerFQ;
	HTREEITEM m_htiDropSourcesHQR;
	HTREEITEM m_htiDropSourcesTimerHQR;
	HTREEITEM m_htiHqrBox;
//dlarge end

//dlarge auto priority
	HTREEITEM hGrpAPrio;
		HTREEITEM hUseAPrio;
		HTREEITEM hAPrioHigh;
		HTREEITEM hAPrioNorm;
		HTREEITEM hAPrioKeepLow;
		bool bUseAPrio;
		bool bAPrioKeepLow;
		int  iAPrioHigh;
		int  iAPrioNorm;
//dlarge end

//dlarge SUC
	HTREEITEM m_htiMoreTweaksGroup;
	bool m_bDynUpMode;
	bool m_bSUCLog;
	int m_iSUCHigh;
	int m_iSUCLow;
	int m_iSUCPitch;
	int m_iSUCDrift;
	HTREEITEM m_htiDynUpSUC;
	HTREEITEM m_htiSUCLog;
	HTREEITEM m_htiSUCHigh;
	HTREEITEM m_htiSUCLow;
	HTREEITEM m_htiSUCPitch;
	HTREEITEM m_htiSUCDrift;
//dlarge end

// NEO: NMX - [NeoMenuXP]
	HTREEITEM m_htiXPMenuStyle;
	HTREEITEM m_htiXPMenuStyleOffice;
	HTREEITEM m_htiXPMenuStyleStartMenu;
	HTREEITEM m_htiXPMenuStyleXP;
	HTREEITEM m_htiShowXPSideBar;
	HTREEITEM m_htiShowXPBitmap;
	HTREEITEM m_htiGrayMenuIcon;
	bool	m_bShowXPSideBar;
	bool	m_bShowXPBitmap;
	int	m_iXPMenuStyle;
	bool	m_bGrayMenuIcon;
// NEO: NMX END

//dlarge CPU/MEM 
	bool m_bSysInfo;
	bool m_bSysInfoGlobal;
	HTREEITEM m_htiSysInfoGroup;
	HTREEITEM m_htiSysInfo;
	HTREEITEM m_htiSysInfoGlobal;
//dlarge CPU/MEM 

//dlarge Display Settings
	bool m_bQueueProgressBar; //dlarge Client queue progress bar 
	HTREEITEM m_htiQueueProgressBar; //dlarge Client queue progress bar 

	bool m_bShowClientPercentage; //dlarge Percentage 
	HTREEITEM m_htiShowClientPercentage; //dlarge Client Percentage 

	bool m_bEnableChunkDots;
	HTREEITEM m_htiEnableChunkDots;

	bool m_bShowSessionDownload;
	HTREEITEM m_htiSessionDownload;

	bool m_bSideBanner;
	HTREEITEM m_htiSideBanner;

	bool	m_bUseRelativeChunkDisplay; 
	HTREEITEM m_htiUseRelativeChunkDisplay; 

//dlarge end

//dlarge minimule 
	bool m_bShowMM;
	bool m_bMMLives;
	int m_iMMUpdateTime;
	int m_iMMTrans;
	bool m_bMMBanner;
	bool m_bMMCompl;
	bool m_bMMOpen;

	HTREEITEM m_htiMMGroup;
	HTREEITEM m_htiShowMM;
	HTREEITEM m_htiMMLives;
	HTREEITEM m_htiMMUpdateTime;
	HTREEITEM m_htiMMTrans;
	HTREEITEM m_htiMMBanner;
	HTREEITEM m_htiMMCompl;
	HTREEITEM m_htiMMOpen;
//dlarge end

//dlarge Smart Category Control 
	HTREEITEM m_htiSCC;
	HTREEITEM m_htiDlMode;
	HTREEITEM m_htiDlNone;
	HTREEITEM m_htiDlAlph;
	HTREEITEM m_htiDlLP;
	HTREEITEM m_htiShowCatNames;
	HTREEITEM m_htiSelectCat;
	HTREEITEM m_htiUseActiveCat;
	HTREEITEM m_htiAutoSetResOrder;
	HTREEITEM m_htiSmallFileDLPush;
	HTREEITEM m_htiResumeFileInNewCat;
	HTREEITEM m_htiUseAutoCat;
//dlarge end

//dlarge Misc Settings
	HTREEITEM m_htiMisc;
	HTREEITEM m_htiSUQWT; //dlarge SUQWT 

	bool m_bStaticIcon;
	HTREEITEM m_htiStaticIcon; 

	bool m_bTrayComplete; 
	HTREEITEM m_htiTrayComplete; 

	bool m_bAutoSharedUpdater;
	HTREEITEM m_htiAutoSharedUpdater; 

	bool	m_bTrayPasswordProtection;
	CString	m_sTrayPassword;

	HTREEITEM m_htiTrayPasswordProtection;
//dlarge end

	afx_msg void OnDestroy();
	afx_msg LRESULT OnTreeOptsCtrlNotify(WPARAM wParam, LPARAM lParam);
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

DECLARE_MESSAGE_MAP()
public:
	void Localize(void);	
	void LoadSettings(void);
	virtual BOOL OnApply();
	virtual BOOL OnInitDialog();
	virtual BOOL OnKillActive();

};
