#pragma once

///////////////////////////////////////////////////////////////////////////////
// Menu commands for GUI only

// Menu entries for the application system menu -> require a set of IDs with special restrictions!
#define MP_RESTORE				0x110
#define MP_CONNECT				0x120
#define MP_DISCONNECT			0x130
#define MP_EXIT					0x140
#define	MP_ABOUTBOX				0x150
#define MP_VERSIONCHECK			0x160
#define MP_MINIMIZETOTRAY		0x170

#define MP_MESSAGE				10102
#define MP_DETAIL				10103
#define MP_ADDFRIEND			10104
#define MP_REMOVEFRIEND			10105
#define MP_SHOWLIST				10106
#define MP_FRIENDSLOT			10107

#define MP_CANCEL				10201
#define MP_STOP					10202
#define MP_PAUSE				10203
#define MP_RESUME				10204
#define	MP_CLEARCOMPLETED		10205
#define	MP_OPEN					10206
#define	MP_PREVIEW				10207
#define MP_CMT					10208
#define MP_HM_CON				10209
#define MP_HM_SRVR				10210
#define MP_HM_TRANSFER			10211
#define MP_HM_SEARCH			10212
#define MP_HM_FILES				10213
#define MP_HM_MSGS				10214
#define MP_HM_IRC				10215
#define MP_HM_STATS				10216
#define MP_HM_PREFS				10217
#define MP_HM_OPENINC			10218
#define MP_HM_EXIT				10219
#define MP_TRY_TO_GET_PREVIEW_PARTS 10220
#define MP_ADDSOURCE			10221
#define MP_ALL_A4AF_AUTO		10222
#define MP_META_DATA			10225
#define MP_BOOT					10226
#define MP_HM_CONVERTPF			10227
#define MP_RESUMEPAUSED			10228
#define MP_HM_KAD				10229
#define MP_HM_LINK1				10230
#define MP_HM_LINK2				10231
#define MP_HM_LINK3				10232
#define MP_HM_SCHEDONOFF		10233
#define MP_HM_HELP				10242
#define MP_HM_1STSWIZARD		10243
#define MP_OPENFOLDER			10244
#define	MP_HM_IPFILTER			10245
#define	MP_WEBSVC_EDIT			10246
#define	MP_HM_DIRECT_DOWNLOAD	10247
#define	MP_VIEW2_CLIENTS		10251
#define	MP_VIEW2_DOWNLOADING	10252
#define	MP_VIEW2_UPLOADING		10253
#define	MP_VIEW2_ONQUEUE		10254
#define MP_VIEW1_SPLIT_WINDOW	10255
#define MP_VIEW1_UPLOADING		10256
#define MP_VIEW1_DOWNLOADS		10257
#define MP_VIEW1_ONQUEUE		10258
#define MP_VIEW1_DOWNLOADING	10259
#define MP_VIEW1_CLIENTS		10260

#define MP_PRIOVERYLOW			10300
#define MP_PRIOLOW				10301
#define MP_PRIONORMAL			10302
#define MP_PRIOHIGH				10303
#define MP_PRIOVERYHIGH			10304
#define MP_GETED2KLINK			10305
#define MP_GETHTMLED2KLINK		10306
#define MP_METINFO				10307
#define MP_PERMALL				10308
#define MP_PERMFRIENDS			10309
#define MP_PERMNONE				10310
#define MP_CONNECTTO			10311
#define MP_REMOVE				10312
#define MP_REMOVEALL			10313
#define MP_REMOVESELECTED		10314
#define MP_UNBAN				10315
#define MP_ADDTOSTATIC			10316
#define MP_CLCOMMAND			10317
#define MP_PRIOAUTO				10317
#define MP_REMOVEFROMSTATIC		10318
#define MP_VIEWFILECOMMENTS		10319
#define MP_CAT_ADD				10321
#define MP_CAT_EDIT				10322
#define MP_CAT_REMOVE			10323
#define MP_SAVELOG				10324
#define MPG_DELETE				10325
#define	MP_COPYSELECTED			10326
#define	MP_SELECTALL			10327
#define	MP_AUTOSCROLL			10328
#define MP_RESUMENEXT			10329
#define MPG_ALTENTER			10330
#define MPG_F2					10331
#define	MP_RENAME				10332
#define	MP_FIND					10333
#define	MP_UNDO					10334
#define	MP_CUT					10335
#define	MP_PASTE				10336
#define MP_DOWNLOAD_ALPHABETICAL 10337
#define MP_A4AF_CHECK_THIS_NOW	10338
#define	MPG_CUT					10339
#define MP_GETKADSOURCELINK		10340
#define MP_SHOWED2KLINK			10341
#define MP_SETSOURCELIMIT		10342
#define MP_CREATECOLLECTION		10343
#define MP_VIEWCOLLECTION		10344
#define MP_MODIFYCOLLECTION		10345
#define MP_SHAREDIR				10346
#define MP_SHAREDIRSUB			10347
#define MP_UNSHAREDIR			10348
#define MP_UNSHAREDIRSUB		10349
#define MP_SEARCHRELATED		10350
#define MP_SEARCHAUTHOR			10351
#define MP_RESTORESEARCHPARAMS	10352
#define	MP_FILTER_RESET			10353
#define	MP_FILTER_APPLY_ALL		10354
#define	MP_FILTER_APPLY_SINGLE	10355
#define	MP_SHOW_FILESIZE_DFLT	10356
#define	MP_SHOW_FILESIZE_KBYTE	10357
#define	MP_SHOW_FILESIZE_MBYTE	10358
#define MP_MARKASSPAM			10359

//dlarge DLCUpPrio
#define MP_PRIOUPVERYLOW		10402
#define MP_PRIOUPLOW			10403
#define MP_PRIOUPNORMAL			10404
#define MP_PRIOUPHIGH			10405
#define MP_PRIOUPVERYHIGH		10406
#define MP_PRIOUPAUTO			10407
//dlarge end

// quick-speed changer
#define MP_QS_U10				10501
#define MP_QS_U20				10502
#define MP_QS_U30				10503
#define MP_QS_U40				10504
#define MP_QS_U50				10505
#define MP_QS_U60				10506
#define MP_QS_U70				10507
#define MP_QS_U80				10508
#define MP_QS_U90				10509
#define MP_QS_U100				10510
#define MP_QS_UPC				10511
#define MP_QS_UP10				10512
#define MP_QS_UPL				10513
#define MP_QS_D10				10521
#define MP_QS_D20				10522
#define MP_QS_D30				10523
#define MP_QS_D40				10524
#define MP_QS_D50				10525
#define MP_QS_D60				10526
#define MP_QS_D70				10527
#define MP_QS_D80				10528
#define MP_QS_D90				10529
#define MP_QS_D100				10530
#define MP_QS_DC				10531
#define MP_QS_DL				10532
#define MP_QS_PA				10533
#define MP_QS_UA				10534

#define MP_WEBURL				10600	// reserve 100 entries for weburls!
#define MP_ASSIGNCAT			10700	// reserve 100 entries for categories!
#define MP_SCHACTIONS			10800	// reserve 100 entries for schedules
#define MP_CAT_SET0				10900	// reserve 100 entries for change all-cats
#define	MP_PREVIEW_APP_MIN		11200	// reserve 50 entries for preview apps
#define	MP_PREVIEW_APP_MAX		(MP_PREVIEW_APP_MIN+49)
#define MP_FILTERCOLUMNS		11300	// reserve 50 entries for filter columsn

#define Irc_Join				10240
#define Irc_Close				10241
#define Irc_Priv				10242
#define Irc_AddFriend			10243
#define	Irc_SendLink			10244
#define Irc_SetSendLink			10245
#define Irc_Kick				10246
#define Irc_Ban					10247
#define Irc_KB					10248
#define Irc_Slap				10249
//Note: reserve at least 50 ID's (Irc_OpCommands-Irc_OpCommands+49).
#define Irc_OpCommands			10250
//Note: reserve at least 100 ID's (Irc_ChanCommands-Irc_ChanCommands+99).
#define Irc_ChanCommands		Irc_OpCommands+50

#define LAST_OFFICIAL_CMD		Irc_ChanCommands;
//>>> WiZaRd::PowerShare
#define MP_POWERSHARE_ON		15000
#define MP_POWERSHARE_OFF		15001
#define MP_AUTOHL_ON			15002
#define MP_AUTOHL_OFF			15003
//<<< WiZaRd::PowerShare
#define	MP_EMF_LOADFRIENDS		15004 //>>> WiZaRd::PNCheck/EMF
//>>> WiZaRd:EMF Link
#define MP_HM_LINK4				15005
//<<< WiZaRd:EMF Link
//>>> WiZaRd::ClipStat
#define MP_STATFEEDBACK			15006 
#define MP_STATFEEDBACK_BB		15007 
//<<< WiZaRd::ClipStat
//>>> WiZaRd::Feedback
#define MP_FILEFEEDBACK			15008
#define MP_FILEFEEDBACK_BB		15009
//<<< WiZaRd::Feedback
#define MP_FILENAME				15010	//>>> shadow2004::FDC [BlueSonicBoy]

#define MP_MASSRENAME    		15011 //dlarge Mass Rename
#define	MP_HM_QUICKSTART		15012 // dlarge QuickStart
//dlarge Drop

#define MP_DROPLOWTOLOWIPSRCS		15013
#define MP_DROPUNKNOWNERRORBANNEDSRCS	15014
#define MP_DROPNONEEDEDSRCS		15015
#define MP_DROPFULLQSRCS		15016
#define MP_DROPHIGHQRSRCS		15017
#define MP_CLEANUP_NNS_FQS_HQRS_NONE_ERROR_BANNED_LOWTOLOWIP	15018
#define MP_DROPQUEUEFULLSRCS	        15019
#define MP_DROPQUEUETOOMANY		15020
#define MP_DROPQUEUEUNKNOWN		15021
#define MP_DROPCONNECTING		15022
#define MP_DROP_ASKING			15023
//dlarge Drop

//dlarge copy feedback feature
#define	MP_COPYFEEDBACK			15024
#define	MP_COPYFEEDBACK_NOCODE	        15025
#define	MP_COPYFORUMLINK		15026
#define MP_ULFEEDBACK                   15027 //dlarge Copy UL-feedback
//dlarge end

#define	MP_LIST_REQUESTED_FILES         15028 //dlarge show requested files
#define MP_STOP_CLIENT			15029 //dlarge Stop Download
#define MP_SCAN				15030 //dlarge Virus Scan

#define MP_SWAP_TO_A4AF			20031
#define MP_SWAP_FROM_A4AF		20032
#define MP_DROP_CLIENT			20033
#define MP_SWAP_TO_CLIENT		20034
#define MP_SWAP_FROM_CLIENT		20035
#define MP_LOCK_CLIENT			20036

#define	MP_HM_TRAY_LOCL			20037  //dlarge TrayPasswordProtection

//dlarge Smart Category Control 
#define MP_CAT_SHOWHIDEPAUSED	20040
#define MP_CAT_SETRESUMEORDER	20041
#define	MP_CAT_ORDERAUTOINC		20042
#define MP_CAT_ORDERSTEPTHRU	20043
#define MP_CAT_ORDERALLSAME		20044
//#define MP_CAT_RESUMENEXT		20045 see MP_RESUMENEXT
#define	MP_CAT_PAUSELAST		20046
#define MP_CAT_STOPLAST			20047
#define MP_CAT_MERGE			20048
#define MP_CAT_DL_MODE          20049
// reserved till 20051
//dlarge end